/****************************************************************************
 MYTH - Database structures/routines
 Coded by Saruk (01/21/99)
 ---
 When I get it right....
 ****************************************************************************/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "db.h"
#include "net.h"
#include "externs.h"

// OBJECTs
OBJECT *deadobj_list = NULL;
OBJECT *exit_list = 0;
OBJECT *thing_list = 0;
OBJECT *player_list = 0;
OBJECT *room_list = 0;
OBJECT *rootobj = 0;
BBOARD *bblist = NULL;

int db_version = 0;
/**********************************************************
 Copy a string into another.
  **********************************************************/
void SET(str, toadd)
	char **str;
	char *toadd;
{
	if(*str)
		*str = NULL;
	if(!toadd || !*toadd)
		*str = NULL;
	else {
		*str = (char *) malloc(strlen(toadd) + 1);
		strcpy(*str, toadd);
	}
		
}

/*******************************************
 Initial database routines.
 *******************************************/
// find out where something is.
object *loc(player)
	object *player;
{
	object *o;
	
	for(o=room_list; o; o=o->next)
		if(o->ref == player->loc)
			return o;
	for(o=player_list; o; o=o->next)
		if(o->ref == player->loc)
			return o;
	for(o=thing_list; o; o=o->next)
		if(o->ref == player->loc)
			return o;
	
	return (NULL);
}

// reference the link.
object *linkit(player)
	object *player;
{
	object *o;
	
	for(o=room_list; o; o=o->next)
		if(o->ref == player->link)
			return o;
	for(o=player_list; o; o=o->next)
		if(o->ref == player->link)
			return o;
	for(o=thing_list; o; o=o->next)
		if(o->ref == player->link)
			return o;
	
	return (NULL);
}

// reference the owner.
object *owner(player)
	object *player;
{
	object *o;
	
	for(o=room_list; o; o=o->next)
		if(o->ref == player->owner)
			return o;
	for(o=player_list; o; o=o->next)
		if(o->ref == player->owner)
			return o;
	for(o=exit_list; o; o=o->next)
		if(o->ref == player->owner)
			return o;
	for(o=thing_list; o; o=o->next)
		if(o->ref == player->owner)
			return o;
	
	return (NULL);
}

// calculates the number of commands on an alias set.
int calculate_cmds(o)
	OBJECT *o;
{
	int ctr = 0;
	CLIST *c;
	
	for(c=o->cmdlist;c;c=c->next)
		ctr++;
		
	return ctr;
}
		
// calculate the size of an objects attribute list (in number of attributes)
int calculate_attrs(o)
	OBJECT *o;
{
	int counter = 0;
	attr *a;
	
	for(a = o->alist; a; a=a->next)
		if(*(atr_get(o, a->name)))
			counter++;
	
	return counter;
}

// this is a temporary procedure. logs the database
void log_database(void)
{	
	OBJECT *o;
	attr *a;
	
	for(o=player_list; o; o=o->next) {
		printf("Player object: %s(%d)\n", o->name, o->ref);
		for(a=o->alist; a; a=a->next)
			printf("\tPlayer attribute: %s(%d)->%s: %s\n",
				o->name, o->ref, a->name, a->value);
	}
	for(o=room_list; o; o=o->next) {
		printf("Room object: %s(%d)\n", o->name, o->ref);
		for(a=o->alist; a; a=a->next)
			printf("\tRoom attribute: %s(%d)->%s: %s\n",
				o->name, o->ref, a->name, a->value);
	}
	for(o=exit_list; o; o=o->next) {
		printf("Exit object: %s(%d)\n", o->name, o->ref);
		for(a=o->alist; a; a=a->next)
			printf("\tExit attribute: %s(%d)->%s: %s\n",
				o->name, o->ref, a->name, a->value);
	}
	for(o=thing_list; o; o=o->next) {
		printf("Thing object: %s(%d)\n", o->name, o->ref);
		for(a=o->alist; a; a=a->next)
			printf("\tThing attribute: %s(%d)->%s: %s\n",
				o->name, o->ref, a->name, a->value);
	}
}

// this is where we calculate the size of the database.
int calculate_dbsize(void)
{
	int counter = 0;
	OBJECT *o;
	
	for(o=player_list;o;o=o->next)
		counter++;
	for(o=room_list;o;o=o->next)
		counter++;
	for(o=exit_list;o;o=o->next)
		counter++;
	for(o=thing_list;o;o=o->next)
		counter++;
		
	return counter;
}


int get_topdb(void)
{
	int top = -1;
	object *o;
	
	for(o = player_list; o; o=o->next)
		if(o->ref > top)
			top = o->ref;
	for(o = thing_list; o; o=o->next)
		if(o->ref > top)
			top = o->ref;
	for(o = room_list; o; o=o->next)
		if(o->ref > top)
			top = o->ref;
	for(o = exit_list; o; o=o->next)
		if(o->ref > top)
			top = o->ref;
	
	return(top+1);		
}

// get a free database number.
int db_num(void)
{
	int *array;
	OBJECT *o;
	int db_top = 0, last_num = -1;
	
	db_top = get_topdb();
	array = calloc(db_top, sizeof(int));
	for(o = player_list; o; o=o->next)
		array[o->ref] = 1;
	for(o = thing_list; o; o=o->next)
		array[o->ref] = 1;
	for(o = room_list; o; o=o->next)
		array[o->ref] = 1;
	for(o = exit_list; o; o=o->next)
		array[o->ref] = 1;
	for(last_num = 0; last_num < db_top ;++last_num)
		if(!array[last_num])
			break;
	free(array);
	return(last_num);
}

// purge an object from the appropriate list.
object *delete_object(player, olist, ref)
	object *player;
	object *olist;
	int ref;
{
	object *o, *oprev = NULL;
	
	for(o = olist; o; o=o->next) {
		if(o->ref == ref)
			break;
		oprev = o;
	}
	
	if(!o)
		return olist;
	
	if(!oprev)
		olist = o->next;
	else
		oprev->next = o->next;
	
	clear_channels(o);
	free_mail(o);
	
	if(o->name)
		free(o->name);
	if(o->desc)
		free(o->desc);
	if(o->pass)
		free(o->pass);
	if(o->alist)
		KILL_ATTRS(o);

	free(o);	
	
	return olist;
}

// create a database object and link it to the appropriate list.
object *create_object(owner, type, name)
	dbref owner;
	int type;
	char *name;
{
	object *o;
	
	GENERATE(o, OBJECT);
	o->ref = db_num();
	o->owner = owner;
	o->flags = type;
	o->name = NULL;
	o->pass = NULL;
	o->desc = NULL;
	SET(&o->name, strip_color(name));
	SET(&o->pass, "*");
	SET(&o->desc, return_config("default_description"));

	o->location = 0;
	o->linkto = 0;
	o->contents = 0;
	o->cmdlist = 0;
	o->mail = NULL;
	o->channels = 0;
	
	// this will set the object up with it's initial attributes.
	o->alist = NULL;
	SET_ATR(o, "Rainbow", name);
	SET_ATR(o, "Created", pstr("%ld", time(0)));


	if(type == TYPE_PLAYER) {
		SET(&o->pass, mcrypt(return_config("default_password")));
		
		o->owner = o->ref;
		o->loc = 0;
		o->link = o->loc;
		o->powlvl = PLAYER_POWINIT;
		o->next = player_list;
		player_list = o;
	} else if (type == TYPE_ROOM) {
		o->link = o->ref;
		o->loc = o->ref;
		o->powlvl = ROOM_POWINIT;
		o->next = room_list;
		room_list = o;
	} else if (type == TYPE_EXIT) {
		o->loc = -1;	// this is meant to be defined in exit_create.
		o->link = o->loc;
		o->powlvl = EXIT_POWINIT;
		o->next = exit_list;
		exit_list = o;
	} else if (type == TYPE_THING) {
		o->loc = o->owner;
		o->link = o->loc;
		o->powlvl = THING_POWINIT;
		o->next = thing_list;
		thing_list = o;
	} else {
		printf("[ERROR]: Invalid object type!\n");
		return (NULL);
	}

	return o;	
}

/*******************************************
 Database IN/OUT routines...
 *******************************************/
// Object IN.
int IN_OBJ(fp)
	FILE *fp;
{
	OBJECT *o;
	int cmdnum, index, attrnum;
	
	GENERATE(o, OBJECT);
	o->ref = getint(fp);
	SET(&o->name, getstring(fp));
	SET(&o->desc, getstring(fp));
	SET(&o->pass, getstring(fp));
	o->flags = getlong(fp);
	o->powlvl = getint(fp);
	o->owner = getint(fp);
	o->loc = getint(fp);
	o->link = getint(fp);
	o->linkto = 0;
	o->alist = 0;
	o->location = 0;
	o->contents = 0;
	o->cmdlist = 0;
	o->location = loc(o);
	o->mail = NULL;
	o->channels = 0;
	
	attrnum = getint(fp);
	for(index = 0; index < attrnum; index++)
		mkattr(o, getstring(fp));
	
	check_attrs(o);
	
	cmdnum = getint(fp);
	for(index = 0; index < cmdnum; index++) 
		o->cmdlist = mkcmd(o->cmdlist, getstring(fp));

	if(*(getstring(fp)) != '\\')
		return 0;

	if(o->flags & TYPE_PLAYER) {
		o->next = player_list;
		player_list = o;	
	} else if (o->flags & TYPE_ROOM) {
		o->next = room_list;
		room_list = o;
	} else if (o->flags & TYPE_EXIT) {
		o->next = exit_list;
		exit_list = o; //o->next;
	} else if (o->flags & TYPE_THING) {
		o->next = thing_list;
		thing_list = o;
	} else {
		printf("ERROR: Invalid object type, skipping object.\n");
	}
	
	return 1;
}

int IN_BBLIST(fp)
	FILE *fp;
{
	BBOARD *b;
	object *o;
	char *title = NULL;
	char *message = NULL;
	int created, c_ref, num_read, expiration;
	
	SET(&title, getstring(fp));
	c_ref = getint(fp);
	SET(&message, getstring(fp));
	created = getlong(fp);
	expiration = getlong(fp);
	num_read = getint(fp);
	if(*(getstring(fp)) != '\\')
		return 0;
		
	if(!(o = match_player(pstr("%d", c_ref)))) 
		return 0;
		
	b = add_to_board(o, title, message);
	b->created = created;
	b->expiration = expiration;
	b->num_read = num_read;
	
	return 1;
}

// For database loading... set locations
void set_locations(void)
{
	OBJECT *o;
	
	for(o=room_list; o; o=o->next)
		o->location = loc(o);
	for(o=player_list; o; o=o->next)
		o->location = loc(o);
	for(o=exit_list; o; o=o->next)
		o->location = loc(o);
	for(o=thing_list; o; o=o->next)
		o->location = loc(o);
}

// For database loading... set links
static void set_links(void) 
{
	OBJECT *o;
	
	for(o=room_list; o; o=o->next)
		o->linkto = linkit(o);
	for(o=player_list; o; o=o->next)
		o->linkto = linkit(o);
	for(o=exit_list; o; o=o->next)
		o->linkto = linkit(o);
	for(o=thing_list; o; o=o->next)
		o->linkto = linkit(o);
}

// For database loading... set ownership
void set_ownership(void)
{
	OBJECT *o;
	
	for(o=room_list; o; o=o->next)
		o->ownit = owner(o);
	for(o=player_list; o; o=o->next)
		o->ownit = owner(o);
	for(o=exit_list; o; o=o->next)
		o->ownit = owner(o);
	for(o=thing_list; o; o=o->next)
		o->ownit = owner(o);
	
}

// Store the contents of a 'thing'.
static void store_contents(thing)
	object *thing;
{
	object *o;

	for(o=player_list; o; o=o->next)
		if(o->location == thing)
			add_content(thing, o);
				
	for(o=thing_list;o;o=o->next)
		if(o->location == thing)
			add_content(thing, o);
	
	for(o=exit_list;o;o=o->next)
		if(o->location == thing)
			add_content(thing, o);
	
}

// Reference object contents. EXITS are not allowed to have contents. 
void reference_contents()
{
	object *o;
	
	for(o=player_list; o; o=o->next)
		store_contents(o);
	for(o=room_list; o; o=o->next)
		store_contents(o);
	for(o=thing_list; o; o=o->next)
		store_contents(o);
}

// this will set the root object - on error, the entire MYTH will shut down.
void set_rootobj()
{
	object *o;
	
	for(o=player_list; o; o=o->next)
		if(o->ref == ROOTOBJ)
			rootobj = o;
	
	if(!rootobj) {
		printf("** PANIC ** Error finding root object!\n");
		exit(1);
	}
}
		
// Initial load procedure.
void load_database(void)
{
	DESCRIPTOR *d;
	FILE *fp;
	int counter;
	int index;
	
	if ( (fp = fopen(return_config("db_name"),"r")) == NULL) {
		printf("ERROR: Cannot load database!\n");
		// no sense in booting up, eh?
		exit(1);
	}
	
	db_version = getint(fp);
	counter = getint(fp);
	
	if(reboot_style < 2)
		for(d=descriptor_list; d; d=d->next)
			dwrite(d, pstr("|Y+|* |C|Loading |C+|%d |C|database objects...\n", counter));
	
	for(index = 0; index < counter; index++)
		if(!IN_OBJ(fp)) {
			printf("** PANIC ** Corrupted database, exiting!\n");
			shutdown_flag = 1;
			return;
		}
	
	topic_str = NULL;
	SET(&topic_str, getstring(fp));
	if(!strcmpm(topic_str, "NULL")) {
		free(topic_str);
		topic_str = NULL;
	}
	
	counter = getint(fp);
	for(index = 0; index < counter; index ++)
		if(!IN_BBLIST(fp)) 
			printf("** ERROR ** Cannot load bulletin board.\n");
			
		
	fclose(fp);
	
	// REFERENCE the database, nutcase.
	set_locations();
	set_links();
	set_ownership();
	reference_contents();
	set_rootobj();
	
	// now we're going to log it.
	//log_database();	
}

// Object output.
void OUT_OBJ(fp, o)
	FILE *fp;
	OBJECT *o;
{
	attr *a;
	CLIST *c;

	// What object are you?
	fprintf(fp, "%d\n", o->ref);
	
	// We'll save our strings here.
	fprintf(fp, "%s\n", o->name);
	fprintf(fp, "%s\n", o->desc);
	fprintf(fp, "%s\n", o->pass);
	
	// We'll save our integers/longs/etc. here.
	fprintf(fp, "%ld\n", o->flags);
	fprintf(fp, "%d\n", o->powlvl);
	fprintf(fp, "%d\n", o->owner);
	fprintf(fp, "%d\n", o->loc);
	fprintf(fp, "%d\n", o->link);
	
	// Calculate any attributes that may have been newly defined in the default section.
	check_attrs(o);
	
	// We'll save our attribute system here.
	fprintf(fp, "%d\n", calculate_attrs(o));
	for(a = o->alist; a; a=a->next) 
		if(*(atr_get(o, a->name)))
			fprintf(fp, "%d:%d:%s:%s\n", a->powlvl, a->flags, a->name, a->value);
	
	// We'll save our list of aliased commands here.
	fprintf(fp, "%d\n", calculate_cmds(o));
	for(c = o->cmdlist; c; c=c->next)
		fprintf(fp, "%s %s\n", c->cmd, c->send);
	
	fprintf(fp, "\\\n");
}	

void OUT_BBLIST(fp, b)
	FILE *fp;
	BBOARD *b;
{
	fprintf(fp, "%s\n", b->topic);
	fprintf(fp, "%d\n", b->c_ref);
	fprintf(fp, "%s\n", b->message);
	fprintf(fp, "%ld\n", b->created);
	fprintf(fp, "%ld\n", b->expiration);
	fprintf(fp, "%d\n", b->num_read);
	fprintf(fp, "\\\n");
}

int num_bmsgs()
{
	BBOARD *b;
	int num = 0;
	
	for(b=bblist;b;b=b->next) num++;
	
	return num;
}

// Initial save procedure. 
void save_database(filename)
	char *filename;
{
	OBJECT *o;
	BBOARD *b;
	FILE *fp;
	
	if ((fp = fopen(filename,"w")) == NULL) {
		printf("ERROR: Could not create database... EXITING!\n");
		exit(0);
	}
	
	// set all players to !CONNECTED
	fprintf(fp, "%d\n", DB_VERSION);
	fprintf(fp, "%d\n", calculate_dbsize());
	for(o = player_list; o; o=o->next) {
		o->flags &= ~CONNECT;
		OUT_OBJ(fp, o);
	}
	for(o = room_list; o; o=o->next)
		OUT_OBJ(fp, o);
	for(o = exit_list; o; o=o->next)
		OUT_OBJ(fp, o);
	for(o = thing_list; o; o=o->next)
		OUT_OBJ(fp, o);
	fprintf(fp, "%s\n", ((topic_str)) ? topic_str : "NULL");
	
	// Save all the bboard info.
	fprintf(fp, "%d\n", num_bmsgs());
	for(b = bblist; b; b=b->next) 
		OUT_BBLIST(fp, b);
	
	fclose(fp);
}

// Make a fresh new database.
void new_database(void)
{
	OBJECT *o;
	
	create_object(1, TYPE_ROOM, "Zero Room");
	o = create_object(1, TYPE_PLAYER, "Controller");
	o->powlvl = 100;
	o->flags |= WIZARD;
	SET_ATR(o, "Quota", "1000");
	SET_ATR(o, "ChannelQuota", "1000");
	
	save_database(return_config("db_name"));
}

// fork a child process and dump databases.
void fork_and_dump()
{
	char buf[MAX_BUFSIZE], mail[MAX_BUFSIZE], com[MAX_BUFSIZE];
	int child;
	
	log_channel("database", pstr("|Y+|* |W+|(|C+|%s|W+|) |C|Database dumped.",
		get_date(time(0))));

	// Where the database should go.
	sprintf(buf, "saved/%s.%d", return_config("db_name"), database_saves);
	sprintf(mail, "saved/%s.%d", return_config("maildb"), database_saves);
	sprintf(com, "saved/%s.%d", return_config("comdb"), database_saves);
	
	// If not enough memory, use a virtual fork.
	if ( (child = fork()) == -1)
		child = vfork();
	
	if (child == 0) {
		save_database(buf);
		save_database(return_config("db_name"));
		dump_mail(mail);
		dump_mail(return_config("maildb"));
		save_channel_database(return_config("comdb"));
		save_channel_database(com);
		_exit(0);
	} else if (child<0) {
		printf("[ERROR!] Database save failed.\n");
	}
}