/****************************************************************************
 MYTH - Memory Allocation
 Coded by Saruk (04/10/99)
 ---
 An attempt at MYTH's very own stack system.
 ****************************************************************************/
 
#include <stdlib.h>
#include <string.h>

#include "db.h"
#include "net.h"
#include "externs.h"

MSTACK *MYTH_stack = NULL;
MSTACK *MYTH_nonvolatile = NULL;
int total_stack_calls = 0;
int total_stack_frees = 0;

void *stack_em(size, tag)
	size_t size;
	int tag;
{
	MSTACK *addstack;
	
	addstack = (MSTACK *)malloc(sizeof(MSTACK));
	addstack->ptr = malloc(size);
	addstack->size = size;
	if(addstack->ptr != 0)
		memset(addstack->ptr, 0, size);
	if(tag == SOLID) {
		addstack->next = MYTH_nonvolatile;
		MYTH_nonvolatile = addstack;
	} else {
		addstack->next = MYTH_stack;
		MYTH_stack = addstack;
	}
	
	total_stack_calls++;	
	return(addstack->ptr);
}

void __free_stack(stack)
	MSTACK *stack;
{
	MSTACK *s, *sprev = NULL;
	
	for(s = MYTH_stack; s; s=s->next) {
		if(s == stack)
			break;
		sprev = s;
	}
	
	if(!s) 
		return;
	
	if(!sprev)
		MYTH_stack = s->next;
	else
		sprev->next = s->next;
	
	if(s->ptr)
		free(s->ptr);
	total_stack_frees++;
	
	free(s);
}

void clear_stack()
{
	MSTACK *s, *snext;
	
	for(s = MYTH_stack; s; s=snext) {
		snext = s->next;
		__free_stack(s);
	}
	
}

void generate_stack()
{
	FILE *fp;
	MSTACK *s;
	
	fp = fopen("MYTHSTACK", "w");
	for(s = MYTH_stack; s; s=s->next) {
		fprintf(fp, "%p\n", s->ptr);
		fprintf(fp, "%d\n", s->size);
	}
	fclose(fp);
}