/****************************************************************************
 MYTH - Setting attributes, flags, etc.
 Coded by Saruk (02/12/99)
 ---
 All the set routines are active here.
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// So that we can use crypt();
#include <unistd.h>

#include "db.h"
#include "net.h"
#include "externs.h"

// Un-set an attribute flags.
int aflag_unset(setter, player, setflag)
	OBJECT *setter;
	OBJECT *player;
	char *setflag;
{
	int index;
	flags *f;
	attr *a;

	for(index = 0; aflag_table[index].name; index++) {
		f = &aflag_table[index];
		for(a = player->alist; a; a=a->next) {
			if(!strcmpm(a->name, front(setflag))) {
				if(string_prefix(restof(setflag)+1, f->name) && (setter->flags & f->oflags)) {
					a->flags &=~f->flag;
					return 1;
				}
			}
		}
	}
	return M_EBADAFLG;
}

// Set an attribute flag.
int aflag_set(setter, player, setflag)
	OBJECT *setter;
	OBJECT *player;
	char *setflag;
{
	int index;
	flags *f;
	attr *a;
	
	for(index = 0; aflag_table[index].name; index++) {
		f = &aflag_table[index];
		for (a=player->alist; a; a=a->next) {
			if(!strcmpm(a->name,front(setflag))) {
				if(string_prefix(restof(setflag), f->name) && (setter->flags & f->oflags)) {
					a->flags |= f->flag;
					return 1;
				}
			}
		}
	}
	
	return M_EBADAFLG;
}

int HASWIZ(setter, player, flag)
	object *setter;
	object *player;
	int flag;
{
	if ( (setter == player) && (setter->flags & WIZARD) && (flag & WIZARD) )
		return 1;
	
	return 0;
}

// Un-setting flags.
int flag_unset(setter, player, setflag)
	OBJECT *setter;
	OBJECT *player;
	char *setflag;
{
	// we put flags in a hash table so they're easier to parse and unparse.
	int index;
	flags *f;
	
	for(index = 0; flag_table[index].name; index++) {
		f = &flag_table[index];
		if(string_prefix(setflag, f->name) && (setter->flags & f->oflags) 
			&& (player->flags & f->type) && (f->oflags != -1) ) {
#ifdef ROOTONLY_SETWIZ
			if( (f->flag & WIZARD) && setter != rootobj)
				return M_ENOCNTRL;
#endif
			if(HASWIZ(setter,player, f->flag))
				return M_EUNSET;
			player->flags &= ~f->flag;
			if(f->oflags & WIZARD)
				log_channel("log_imp", pstr("|R+|* |W+|(|C+|%s|W+|) |X|%s |C|unset |X|%s's|C| flag|W+|: |Y+|%s",
					get_date(time(0)), color_name(setter, -1), color_name(player, -1), f->name));


			notify(setter, pstr("|C+|[|Y+|FLAG|C+|]|W+|: |C|Flag |Y+|%s|C| unset.",
				f->name));
			return 1;
		}
	}
	
	return M_EBADFLG;	
}

// setting a flag.
int flag_set(setter, player, setflag)
	OBJECT *setter;
	OBJECT *player;
	char *setflag;
{
	int index;
	flags *f;
	
	for(index = 0; flag_table[index].name; index++) {
		f=&flag_table[index];
		if(string_prefix(setflag, f->name) && (setter->flags & f->oflags) && 
			(player->flags & f->type) && (f->oflags != -1) ) {
#ifdef ROOTONLY_SETWIZ
			if( (f->flag & WIZARD) && (setter != rootobj))
				return M_ENOCNTRL;
#endif
			player->flags |= f->flag;
			if(f->oflags & WIZARD)
				log_channel("log_imp", pstr("|R+|* |W+|(|C+|%s|W+|) |X|%s |C|set |X|%s's|C| flag|W+|: |Y+|%s",
					get_date(time(0)), color_name(setter, -1), color_name(player, -1), f->name));

			notify(setter, pstr("|C+|[|Y+|FLAG|C+|]|W+|: |C|Flag |Y+|%s|C| set.",
				f->name));
			return 1;		
		}
	}
	
	return M_EBADFLG;
}


int __find_player(name)
	char *name;
{
	object *check;
	
	if( (check = match_player(strip_color(name))) )
		return 1;

	return 0;	
}

int __allowed_name(name)
	char *name;
{
	if(strchr(name, '%'))
		return 0;
	else if (strchr(name, '+'))
		return 0;
	else if (strchr(name, '!'))
		return 0;
	else if (ISNUM(match_num(name)))
		return 0;
			
	return 1;
}

int __name_player(player, victim, name)
	object *player;
	object *victim;
	char *name;
{
	char stripped[MAX_BUFSIZE];
	
	strcpy(stripped, strip_color(name));
	if( (__find_player(stripped) && (strcmpm(victim->name, stripped))) || !__allowed_name(stripped) ) 
		return M_EILLNAME;

	notify(player, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: |C|Changing|X| %s|C| to |X|%s",
		color_name(victim, -1), name));
	log_channel("log_sens", pstr("|R+|* |X|%s |C|changes |X|%s|C|'s name to|W+|: |X|%s",
		color_name(player, -1), color_name(victim, -1), name));
	SET(&victim->name, stripped);
	SET_ATR(victim, "Rainbow", name);
	notify(victim, "|C+|[|Y+|BUILTIN|C+|]|W+|: |C|Your name has been changed!");
	
	return 1;
}

// Someone should redo this. Currently it edits (allowed to be edited) builtins.
int set_builtin(player, victim, type, newvalue)
	object *player;
	object *victim;
	char *type;
	char *newvalue;
{
	int result;
	
	if(victim->flags & LOCKED)
		return M_EISLOCKED;
		
	if(string_prefix(type, "description")) {
		SET(&victim->desc, newvalue);
		notify(player, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: |M+|DESCRIPTION |B+|for %s |B+|set to|M+| '%s|M+|'|B+|.",
			color_name(victim, -1), newvalue));
		notify(victim, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: %s |B+|set your |M+|DESCRIPTION |B+|to |M+|'%s|M+|'|B+|.",
			color_name(player, -1), newvalue));
		return 1;
	} else if (string_prefix(type, "name")) {
		return __name_player(player, victim, newvalue);
	} else if (string_prefix(type, "powlvl")) {
		if((player->flags & WIZARD) && can_control(player, victim)) {
			if( (atoi(newvalue) > MAX_POWER) || (atoi(newvalue) > player->powlvl)) 
				return M_EEXCESS;
			else if ( atoi(newvalue) < MIN_POWER)
				return M_EINSUFF;
			else if ( player == victim ) 
				return M_ENOCANDO;
			victim->powlvl = atoi(newvalue);
			log_channel("log_imp", pstr("|R+|* |X|%s |C|set |X|%s|C|'s power level to|W+|: |Y+|%d",
				color_name(player, -1), color_name(victim, -1), victim->powlvl));
			notify(player, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: |M+|POWER LEVEL |B+|for %s |B+|set to|M+| '|Y+|%d|M+|'|B+|.",
				color_name(victim, -1), atoi(newvalue)));
			notify(victim, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: %s |B+|set your |M+|POWER LEVEL |B+|to |M+|'|Y+|%d|M+|'|B+|.",
				color_name(player, -1), atoi(newvalue)));
			return 1;
		} else {
			return M_ENOTWIZ;
		}
	} else if (!strcmp(type, "password")) {
		if(!(victim->flags & TYPE_PLAYER))
			return M_ENOPLAY;
		SET(&victim->pass, mcrypt(newvalue));
		notify(player, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: %s |R+|PASSWORD|B+| changed!", 
			color_name(victim, -1)));
		notify(victim, "|C+|[|Y+|BUILTIN|C+|]|W+|: |B+|Your |R+|PASSWORD|B+| is changed!");
		return 1;
	} else if(string_prefix(type, "exitkey")) {
		if(!(victim->flags & TYPE_EXIT))
			return M_ENOTEXIT;
		SET(&victim->pass, newvalue);
		notify(player, pstr("|C+|[|Y+|BUILTIN|C+|]|W+|: %s |M+|EXIT KEY|B+| changed!",
			color_name(victim, -1)));
		return 1;
	} else if (string_prefix(type, "owner")) {
		return change_ownership(player, victim, newvalue);
	} else if (string_prefix(type, "link") || string_prefix(type, "home")) {
		return change_home(player, victim, newvalue);
	} else {
		if((result = atr_set(player, victim, type, newvalue)) > 0)
			notify(player, pstr("|C+|[|Y+|ATTRIBUTE|C+|]|W+|: |C|Attribute |M+|%s|C| set to '|X|%s|C|'.",
				type, newvalue));
		return result;
	}
	
	return M_ENOBLTIN;
}
 
// set an object of arguments.
void do_set(player, arg1, arg2)
	object *player;
	char *arg1;
	char *arg2;
{
	OBJECT *what;
	char buffer[1024];
	
	IS_ARGUMENT(player, (arg1));
	IS_ARGUMENT(player, (front(arg2)));
	IS_ARGUMENT(player, (restof(arg2)));
		
	if(!(what = match_partial(player, front(arg2)))) {
		if(!(what = match_partial(player->location, front(arg2)))) {
			if(!(what = match_object(front(arg2)))) {
				if(!(what = match_special(player, front(arg2)))) {
					error_report(player, M_EILLNAME);
					return;
				}
			}
		}
	}
	
	if(!can_control(player, what)) {
		error_report(player, M_ENOCNTRL);
		return;
	}
	
	if(string_prefix(arg1, "flag")) {
		if(*restof(arg2) == '!') {
			error_report(player, flag_unset(player, what, restof(arg2) + 1));
		} else {
			error_report(player, flag_set(player, what, restof(arg2)));
		}
		return;
	} else if (string_prefix(arg1, "aflag")) {
		strcpy(buffer, restof(arg2));
		if(*restof(buffer) == '!') {
			if (!error_report(player, aflag_unset(player, what, buffer))) return;
			notify(player, pstr("|C+|[|Y+|FLAG|C+|]|W+|: |B+|Attribute Flag |Y+|%s |G+|unset|B+|.", 
				restof(buffer)+1));
		} else {
			if(!error_report(player, aflag_set(player, what, buffer))) return;
			notify(player, pstr("|C+|[|Y+|FLAG|C+|]|W+|: |B+|Attribute Flag |Y+|%s |G+|set|B+|.",
				restof(buffer)));
		}
	} else {
		error_report(player, set_builtin(player, what, arg1, restof(arg2)));
		return;
	}
}


/* Since builtin has been changed to include attribute, this currently changes description or
   attributes */
int edit_builtin(player, victim, attrname, editstr)
	object *player;
	object *victim;
	char *attrname;
	char *editstr;
{
	ATTR *a;
	char findstr[MAX_BUFSIZE], replacestr[MAX_BUFSIZE], savestr[MAX_BUFSIZE];
	char buf[MAX_BUFSIZE], buf2[MAX_BUFSIZE];
	char *p = buf;
	
	if(string_prefix(attrname, "description"))
		strcpy(savestr, victim->desc);
	else if((a = __has_attribute(victim, attrname)))
		strcpy(savestr, atr_get(victim, a->name));
	else
		return M_ENOCANDO;
	
	
	if(!strchr(editstr, '{') || !strchr(editstr, '}'))
		return M_EILLSTRING;
			
	strcpy(buf2, editstr);
	strcpy(findstr, get_inside(buf2, '{', '}', ','));
	strcpy(buf2, buf2 + strlen(findstr) + 2);
	
	if(!strchr(buf2, '{') || !strchr(buf2, '}'))
		return M_EILLSTRING;
		
	strcpy(replacestr, get_inside(buf2, '{', '}', ','));

	strcpy(buf2, "");
	if(!(p = strstr(savestr, findstr)) || !*findstr)
		return M_ENOTFOUND;
	
	strcpy(buf, p);
	savestr[strlen(savestr) - strlen(p)] = '\0';	
	strcpy(buf2, p + strlen(findstr));
	sprintf(buf, "%s%s%s", savestr, replacestr, buf2);

	if(string_prefix(attrname, "description")) {
		SET(&victim->desc, (*buf) ? buf : "");
		notify(player, pstr("|C+|[|Y+|EDIT|C+|]|W+|: |C|Description changed to '|X|%s|C|'.",
			buf));
		return 1;
	} else {
		if(error_report(player, atr_set(player, victim, a->name, buf)))
			notify(player, pstr("|C+|[|Y+|EDIT|C+|]|W+|: |C|Attribute |Y+|%s|C| changed to '|X|%s|C|'.",
				a->name, buf));
		return 1;
	}
	
	return 0;
}

void do_edit(player, arg1, arg2)
	object *player;
	char *arg1;
	char *arg2;
{
	object *what;
	
	IS_ARGUMENT(player, (arg1));
	IS_ARGUMENT(player, (front(arg2)));
	IS_ARGUMENT(player, (restof(arg2)));

	if(!(what = match_partial(player, front(arg2)))) {
		if(!(what = match_partial(player->location, front(arg2)))) {
			if(!(what = match_object(front(arg2)))) {
				if(!(what = match_special(player, front(arg2)))) {
					error_report(player, M_EILLNAME);
					return;
				}
			}
		}
	}	

	if(what->flags & LOCKED) {
		error_report(player, M_EISLOCKED);
		return;
	}

	if(!can_control(player, what)) {
		error_report(player, M_ENOCNTRL);
		return;
	}
	error_report(player, edit_builtin(player, what, arg1, restof(arg2)));
}