/****************************************************************************
 MYTH - Command List
 Coded by Saruk (03/26/99)
 ---
 Keep track of all the useabl commands.
 ****************************************************************************/
 
#define PURITY 	0x1
#define TEXT	0x2
#define NOAMB	0x4	// No ambiguous matching.
// #define SPEAK_SAY 0x8
// #define SPEAK_POSE 0x10
// #define SPEAK_POSS 0x20
// #define SPEAK_THINK 0x40
// #define SPEAK_TO 0x80
// #define WIZARD 0x400 - this is defined in db.h, just to note that it is used here.

struct cmd_list_t {
	char *command;
	void (*func)();
	int flags;
	int powerlevel;
};

/*
    When flagging an ambiguous command, make sure you move it to the front
of it's
alphabetical partners. Elsewise, you don't really get to use said command
first.
*/
struct cmd_list_t cmdlist[]={
        {"alias", do_alias, 0, 25},
        {"as", do_as, 0, 25},
        {"board", do_board, 0, 25},
        {"boot", do_boot, WIZARD, 75},
	{"cboot", do_cboot, PURITY|WIZARD, 75},
	{"channel", do_channel, 0, 25},
	{"comment", do_comment, PURITY, 25},
	{"create", do_create, 0, 25},	
        {"dig", do_dig, 0, 25},
        {"dbinfo", do_dbinfo, 0, 25},
        {"drop", do_drop, 0, 25},
        {"examine", do_examine, NOAMB, 25},
        {"edit", do_edit, 0, 25},
        {"exitdel", do_remove_exit, 0, 25},
        {"help", do_help, TEXT|NOAMB, 0},
        {"home", do_home, 0, 0},
        {"join", do_join, NOAMB, 75},
	{"look", do_look, NOAMB, 0},
        {"listalias", do_alias_list, 0, 25},
        {"listcmd", do_listcmd, 0, 0},
        {"mail", do_mail, 0, 25},
        {"man", do_help, TEXT, 0},
        {"news", do_help, TEXT, 0},
        {"page", do_page, NOAMB, 10},
        {"paste", start_paste, PURITY, 25},
        {"pcreate", do_pcreate, WIZARD, 75},
        {"pose", NULL, SPEAK_POSE, 5}, 
        {"precycle", do_precycle, WIZARD, 100},
        {"reboot", do_reboot, WIZARD, 75}, 
        {"recycle", do_recycle, 0, 25},
        {"report", do_report, 0, 25},
        {"roomjoin", do_roomjoin, 0, 25},
        {"say", NULL, SPEAK_SAY, 5},
        {"search", do_search, 0, 25},
        {"set", do_set, 0, 25},
        {"shutdown", do_shutdown, WIZARD, 100},
        {"summon", do_summon, 0, 75},
        {"take", do_take, 0, 25},
        {"teleport", do_teleport, 0, 25}, 
        {"think", NULL, SPEAK_THINK, 5},
        {"uptime", do_uptime, 0, 0},
        {"version", do_version, 0, 0},
        {"who", do_who, NOAMB, 0},
        {"wall", do_wall, 0, 25},  
	{NULL}};