/****************************************************************************
 MYTH - Configuration Header
 Coded by Saruk (01/10/99)
 ---
 Holds general information on MYTH structures and static variables.
 ****************************************************************************/

#include "credits.h"

// Macro Definitions
#define P(x)		x
#define DOEXTERN(x,y)	extern x y
#define GENERATE(a, b)	(a = (b *)malloc(sizeof(b)))

// Basic Definitions
// Only root can do this:
#define ROOTONLY_SETWIZ

#define FALSE		0
#define TRUE		1
#define GUEST_PREFIX	"Guest"	// Prefix for the guest name.
#define ROOTOBJ		1	// This determines which object to assign as the rootobj. 
#define INIT_QUOTA	1	// This is nota  free for all, so no quota.
#define INIT_CHQUOTA	1	// Channel quota.
#define MIN_POWER	-100	// set the minimum powerlevel.
#define MAX_POWER	100	// set the maximum powerlevel.
#define MIN_BUFSIZE	1024	// Minimum buffer size.
#define MED_BUFSIZE	1024	// Medium buffer size.
#define MAX_BUFSIZE	1024	// Maximum buffer size.
#define HUGE_BUFSIZE	10000	// HUGE buffer size.
#define MAX_IOINPUT	1000	// Maximum of 1000 chars at a time, to reduce overflow chances.
#define MAX_GUESTS	3
#define NEXT_LOOKUP	150	// Lookup a host.
#define CAN_WALLOFF	75	// powerlevel to wall official something.
#define DEF_BBEXP	15	// Expiration of Bulletin Board items in days.
#define BOARD_MAX	10	// Maximum of 10 board messages per player.

// Speech definitions/tokens.
/** We have to change these for flags in cmdlist.h **/
#define SPEAK_SAY	0x8
#define SPEAK_POSE	0x10
#define SPEAK_POSS	0x20
#define SPEAK_THINK 	0x40
#define SPEAK_TO	0x80

#define POSS_TOKEN	';'
#define THINK_TOKEN	'.'
#define CHAN_TOKEN	'='
#define POSE_TOKEN	':'
#define TO_TOKEN	'\''
#define SAY_TOKEN	'"'

// Type definitions.
typedef int dbref;
typedef dbref DBREF;

// External variables.
extern char *wildptr[];
extern char wildbuff[];
extern int wildlen[];
#include "extvars.h"