/****************************************************************************
 MYTH - External Calls
 Coded by Saruk (01/12/99)
 ---
 Keep all the external calls here. And include this file in all your files.
 ****************************************************************************/

/* For some versions of Linux, this gets rid of the implict warning */
#ifdef __GLIBC__
extern char *crypt P((char *, char *));
#endif


/* From admin.c */
extern void do_as P((OBJECT *, char *, char *));

/* From ansi.c */
extern char *colourize P((char *));
extern char *format_color P((char *, int));
extern char *truncate_color P((char *, int));
extern char *strip_color P((char *));
extern char *color_name P((object *, int));

/* From attrib.c */
extern void SET_ATR P((object *, char *, char *));
extern void KILL_ATTRS P((object *));
extern void mkattr P((object *, char *));
extern void check_attrs P((object *));
extern attr *__has_attribute P((object *, char *));
extern char *atr_get P((object *, char *));
extern int atr_set P((object *, object *, char *, char *));
extern int __is_attribute P((char *));
extern void atr_examine P((object *, object *, char *));

/* From board.c */
extern void sort_bboard P((void));
extern void do_board P((object *, char *, char *));
extern BBOARD *add_to_board P((object *, char *, char *));

/* From channels.c */
extern void log_channel P((char *, char *));
extern void paste_channel P((object *, char *, char *));
extern int channel_paste_header P((DESCRIPTOR *, char *, int));
extern void clear_channels P((object *));
extern int match_channels P((object *, char *, char *));
extern void do_channel P((object *, char *, char *));
extern void do_channel_default P((object *, char *));
extern void notify_channel P((CHANNEL *, CHANNEL *, char *));
extern CHANNEL *__create_channel P((char *, char *));
extern CHANNEL *__add_channel P((object *, CHANNEL *));

/* From channeldb.c */
extern void save_channel_database P((char *));
extern void load_channel_database P((void));

/* From comm.c */
extern char *substitute P((char *));
extern void notify P((object *, char *));
extern void clear_exception P((CONTENTS *));
extern void add_exception P((CONTENTS **, object *));
extern void notify_in P((object *, CONTENTS *, char *));
extern void __notify P((object *, char *, int));
extern void perm_denied P((object *, char *));
extern void do_page P((object *, char *, char *));
extern void do_wall P((object *, char *, char *));

// Separate because it takes up so much. 
extern void do_speak P((object *, char *, int));
extern char *speech_parse P((object *, char *));
#define DO_SAY(player, sendstr)	do_speak(player, sendstr, SPEAK_SAY);
#define DO_POSE(player, sendstr) do_speak(player, sendstr, SPEAK_POSE);
#define DO_POSS(player, sendstr) do_speak(player, sendstr, SPEAK_POSS);
#define DO_THINK(player, sendstr) do_speak(player, sendstr, SPEAK_THINK);
#define DO_TO(player, sendstr) do_speak(player, sendstr, SPEAK_TO);

/* From command.c */
extern CLIST *mkcmd P((CLIST *, char *));
extern void filter_command P((object *, char *));
extern void do_reboot P((object *, char *));
extern void do_shutdown P((object *));
extern void do_listcmd P((object *));
extern void do_alias P((object *, char *, char *));
extern void do_alias_list P((object *, char *));

/* From create.c */
extern void do_roomjoin P((object *, char *, char *));
extern void do_create P((object *, char *));
extern void do_dig P((object *, char *, char *));

/* From db.c */
extern void SET P((char **, char *));
extern object *linkit P((object *));
extern int calculate_dbsize P((void));
extern object *loc P((object *));
extern object *delete_object P((object *, object *, int));
extern void load_database P((void));
extern void save_database P((char *));
extern void new_database P((void));
extern object *create_object P((dbref, int, char *));
extern void fork_and_dump P((void));

/* From error.c */
extern int call_error_report P((object *, int, int, char *));
#define error_report(a, b) call_error_report(a, b, __LINE__, __FILE__)

/* From examine.c */
extern void do_examine P((object *, char *, char *));
/* From fileutil.c */
extern int getint P((FILE *));
extern char *getstring P((FILE *));
extern long getlong P((FILE *));

/* From help.c */
extern void do_uptime P((object *));
extern void do_version P((object *));
extern void do_help P((object *, char *, char *));

/* From hooks.c */
extern void setup_hooks P((void));

/* From locks.c */
extern char *get_chunk P((char *, int, int));
extern int lock_power P((object *, char *));
extern int lock_flag P((object *, char *));
extern int parse_lock P((object *, char *));

/* From look.c */
extern void do_look P((object *, char *));
extern void do_who P((object *, char *, char *));
extern void do_who_is P((object *, char *));
extern void do_comment P((object *, char *));

/* From mail.c */
extern void free_mail P((object *));
extern void __announce_mail P((object *));
extern void save_mail P((char *));
extern void load_mail P((void));
extern void dump_mail P((char *));

/* From match.c */
extern int match_num P((char *));
extern object *match_combatable P((object *, char *));
extern object *match_special P((object *, char *));
extern object *match_partial P((object *, char *));
extern object *match_moveable P((char *));
extern object *match_thing P((char *));
extern object *match_player P((char *));
extern object *match_room P((char *));
extern object *match_exit P((char *));
extern object *match_object P((char *));

/* From memory.c */
extern void generate_stack P((void));
extern void *stack_em P((size_t, int));
extern void clear_stack P((void));

/* From objects.c */
extern int change_home P((object *, object *, char *));
extern int change_ownership P((object *, object *, char *));
extern char *unparse_object P((object *));
extern void do_drop P((object *, char *));
extern void do_take P((object *, char *));
extern void add_content P((object *, object *));
extern void del_content P((object *, object *));
extern void do_teleport P((object *, char *, char *));
extern char *flaglist P((object *));
extern char *aflaglist P((int));

/* From paste.c */
extern void do_paste P((DESCRIPTOR *, char *));
extern void start_paste P((object *, char *));

/* From player.c */
extern void do_home P((object *));
extern void do_remove_exit P((object *, char *));
extern void guest_precycle P((object *, object *));
extern void do_join P((object *, char *));
extern void do_summon P((object *, char *));
extern int move_to P((object *, object *));
extern void do_recycle P((object *, char *, char *));
extern void do_precycle P((object *, char *, char *));
extern object *create_player P((object *, char *, char *));
extern void do_pcreate P((object *, char *, char *));
extern int match_type P((object *, char *));
extern void do_cboot P((object *, char *));

extern int can_control P((object *, object *));
extern int connected_player P((object *));
extern void do_boot P((object *, char *, char *));

/* From report.c */
extern void do_dbinfo P((object *));
extern void do_report P((object *, char *, char *));
extern void do_search P((object *, char *, char *));

/* From softcode.c */
extern void softcode_startup P((void));

/* From stringutil.c */
extern int NULLIFIED P((char *));
extern char *mcrypt P((char *));
extern int dcrypt P((char *, char *));
extern char *lfof P((char *, int));
extern char *stringalloc P((char *));
#define stralloc stringalloc
extern int isanumber P((char *));
extern char *get_inside P((char *, int, int, int));
extern char *flip P((char *));
extern int ISNUM P((int));
extern char *rjust P((char *, int));
extern char *comma P((int));
extern void make_header P((object *, char *));
extern int match_key P((char *, char *));
extern char *rparse P((char *, int));
extern char *fparse P((char *, int));
extern char *parse_it P((char **, int));
extern char *lower_case P((char *));
extern char to_upper P((int));
#define LC(x) lower_case(x)
extern char *make_ln P((char *, int));
extern char *cjust P((char *, int));
extern int string_prefix P ((char *, char *));
extern int strcmpm P((char *, char *));
#ifndef NO_PROTO_VARARGS
extern char *pstr P((char *, ...))
#ifdef __GNUC__
__attribute__ ((format (printf, 1, 2)))
#endif
;
#endif

/* io.c */
extern TQUEUE *TQUEUE_FREE P((TQUEUE *));
extern void do_resock P((void));
extern void do_command P((DESCRIPTOR *, char *));
extern void connect_player P((DESCRIPTOR *));
extern void dwrite P((DESCRIPTOR *, char *));
extern void shutdownsock P((dbref, char *));
extern void boot_off P((dbref));
extern void dfree P((int));

/* From iomisc.c */
extern void world_dwrite P((char *));
extern void world_dwrite_q P((char *));
extern int display_file P((DESCRIPTOR *, char *));
extern int show_welcome P((DESCRIPTOR *));

/* From mail.c */
extern void do_mail P((object *, char *, char *));

/* From set.c */
extern void do_edit P((object *, char *, char *));
extern int __find_player P((char *));
extern int __allowed_name P((char *));
extern int __name_player P((object *, object *, char *));
extern void do_set P((object *, char *, char *));

/* From text.c */
extern void do_text P((object *, char *, char *));

/* From timer.c */
extern char *get_date P((time_t));
extern char *time_format2 P((time_t));
extern char *time_format P((time_t));
extern char *count_idle P((time_t));
extern void do_timer P((void));

/* From tools.c */
extern void setup_myth P((void));
extern int load_config P((void));
extern void list_config P((object *));
extern char *return_config P((char *));

// these WILL be changed over to stringutil.c later
extern char *front P((char *));
extern char *restof P((char *));

/* From trigger.c */
extern char *show_pseudo_exit P((char *));
extern int match_pseudo_exit P((object *, char *));
extern int match_real_exit P((object *, char *));
extern void take_trigger P((object *, object *));
extern void exit_trigger P((object *, object *));

/* Include World Macros */
#include "macros.h"
