/****************************************************************************
 MYTH - Net Header
 Coded by Saruk (01/10/99)
 ---
 Our network header file. For descriptor list and text queues.
 ***************************************************************************/

#include <sys/types.h>
#include <netinet/in.h>

#define MAX_OUTPUT	300

#define WAITCONNECT	0
#define WAITPASS	1
#define CONNECTED	2
#define RELOADCONNECT	3

#define SET_DONE	0
#define SET_EDITOR	1

typedef struct txt_queue {
	char *buffer;
	int num_lines;
	
	struct txt_queue *next;
} TQUEUE;

typedef struct descriptor_data {
	int ref;
	int state;
	int descriptor;
	int internal;
	int input_flag;
	int paste_flag;
	int output_flag;
	int output_lines;
	int paste_lines;

	long connected_at;
	long last_time;
		
	char addr[51];
	char *paste_cmd;
	
	object *player;
	TQUEUE *input_queue;
	TQUEUE *paste_queue;
	TQUEUE *output_queue;
		
	struct sockaddr_in address;
	struct descriptor_data *next;
} DESCRIPTOR;

extern struct descriptor_data *descriptor_list;
