/****************************************************************************
 MYTH - Server Hooks
 Coded by Saruk (04/09/99)
 ---
 These keep the malloc hooks and what not.
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

#include "db.h"
#include "net.h"
#include "externs.h"

#ifdef MALLOCREPORT
static void *old_malloc_hook;
static void *__new_malloc_hook(size)
	size_t size;
{
	void *result;
	
	__malloc_hook = old_malloc_hook;
	result = malloc(size);
	num_mallocs++;
	tot_mem_act += (unsigned int)size;
	__malloc_hook = __new_malloc_hook;
	
	return(result);
}

static void *old_free_hook;
static void __new_free_hook(ptr)
	void *ptr;
{
	__free_hook = old_free_hook;
	free(ptr);
	num_frees++;
	__free_hook = __new_free_hook;
}
#endif /*MALLOCREPORT*/

void setup_hooks()
{

#ifdef MALLOCREPORT
	/** Memory Allocation Hooks **/
	old_malloc_hook = __malloc_hook;
	old_free_hook = __free_hook;
	__malloc_hook = __new_malloc_hook;
	__free_hook = __new_free_hook;
#endif /*MALLOCREPORT*/

}