/****************************************************************************
 MYTH - Paste/Edit utilities.
 Coded by Saruk (01/29/99)
 ---
 Crappy paste functions.
 ****************************************************************************/
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "db.h"
#include "net.h"
#include "externs.h"

void add_paste(d, buffer)
	DESCRIPTOR *d;
	char *buffer;
{
	TQUEUE *t, *tnew, *tprev = NULL;
		
	for(t=d->paste_queue; t; t=t->next)
		tprev = t;
	
	GENERATE(tnew, TQUEUE);
	tnew->buffer = NULL;
	SET(&tnew->buffer, buffer);
	tnew->next = NULL;
	
	if(!tprev)
		d->paste_queue = tnew;
	else
		tprev->next = tnew;	
}

int HEADER_PASTE(d, tag)
	DESCRIPTOR *d;
	int tag;
{
	object *o;
	char player_name[MAX_BUFSIZE];
	
	
	strcpy(player_name, color_name(d->player, -1));
	if(!strcmpm(front(d->paste_cmd), "channel"))
		return error_report(d->player, channel_paste_header(d, restof(d->paste_cmd), tag));
	else if (!strcmpm(d->paste_cmd, "me")) {
		if(tag)
			notify(d->player, "|C+|--- |C|Personal Paste Buffer |C+|---");
		else
			notify(d->player, "|C+|--- |C|End of Personal Paste Buffer |C+|---");
		return TRUE;
	} else if (!strcmpm(d->paste_cmd, "here")) {
		if(tag)
			notify_in(d->player->location, NULL, pstr("|C+|--- |C|Paste Buffer From |X|%s |C|in |X|%s |C+|---",
				player_name, color_name(d->player->location, -1)));
		else
			notify_in(d->player->location, NULL, pstr("|C+|--- |C|End of Paste Buffer From |X|%s |C|in |X|%s |C+|---",
				player_name, color_name(d->player->location, -1)));
		return TRUE;
	} else if (!strcmpm(d->paste_cmd, "command")) {
		if(tag)
			notify(d->player, "|C+|--- |C|Sending Commands From Buffer |C+|---");
		else
			notify(d->player, "|C+|--- |C|End of Commands From Buffer |C+|---");
		return TRUE;
	} else {
		if(!(o = match_player(d->paste_cmd)))
			return FALSE;
		if(tag) 
			notify(o, pstr("|C+|--- |C|Paste Buffer From |X|%s |C+|---",
				player_name));
		else {
			notify(o, pstr("|C+|--- |C|End of Paste Buffer From |X|%s |C+|---",
				player_name));
			notify(d->player, pstr("|C+|[|Y+|PASTE|C+|]|W+|: |C|Paste sent to |X|%s",
				color_name(o, -1)));
		}
		return TRUE;
	}
}

void paste_buffer(d)
	DESCRIPTOR *d;
{
	object *o;
	TQUEUE *t;
	
	if(!d->paste_queue) {
		dwrite(d, "|C+|[|Y+|PASTE|C+|]|W+|: |B+|Empty paste buffer.");
		return;
	}
	
	if(!HEADER_PASTE(d, TRUE))
		return;
	
	for(t = d->paste_queue; t; t = t->next) {
			if (!strcmpm(front(d->paste_cmd), "channel"))
				paste_channel(d->player, restof(d->paste_cmd), t->buffer);
			else if (!strcmpm(d->paste_cmd, "me"))
				notify(d->player, t->buffer);
			else if (!strcmpm(d->paste_cmd, "here"))
				notify_in(d->player->location, NULL, t->buffer);
			else if (!strcmpm(d->paste_cmd, "command")) {
				/* Make sure it doesn't call any commands that may require added input. */
				if(strcmpm(front(t->buffer), "paste") || strcmpm(front(t->buffer),"editor"))
					filter_command(d->player, t->buffer);
			} else {
				if(!(o = match_player(d->paste_cmd)))
					break;	
				notify(o, t->buffer);
			}
		}
		
	d->paste_queue = TQUEUE_FREE(d->paste_queue);
	HEADER_PASTE(d, FALSE);
	
}

void do_paste(d, buffer)
	DESCRIPTOR *d;
	char *buffer;
{
	if (!strcmpm(buffer, ".abort")) {
		d->paste_queue = TQUEUE_FREE(d->paste_queue);
		if(d->paste_cmd)
			free(d->paste_cmd);
		d->paste_flag = 0;
		dwrite(d, "|C+|[|Y+|PASTE|C+|]|W+|: |B+|PASTE |G+|aborted|B+|.\n");
	} else if(!strcmp(buffer, ".")) {
		paste_buffer(d);
		if(d->paste_cmd)
			free(d->paste_cmd);
		d->paste_flag = 0;
	} else { 
		add_paste(d, buffer);
	}
}

char *paste_parse(arg1)
	char *arg1;
{
	object *o;
	// if no argument, assume personal.
	if(!*arg1)
		return "here";
	
	if(!strcmpm(arg1, "me") || !strcmpm(arg1, "here"))
		return arg1;
	else if (!strcmpm(front(arg1), "channel"))
		return arg1;
	else if (!strcmpm(arg1, "command"))
		return arg1;
	else {
		if(!(o = match_player(arg1)))
			return "";
		else
			return o->name;
	}
}

void start_paste(player, arg1)
	object *player;
	char *arg1;
{
	DESCRIPTOR *d;
	char *cmd;
	
	for(d=descriptor_list; d; d=d->next)
		if(d->state == CONNECTED && d->player)
			if(d->player == player)	
				break;

	if(!d)
		return;
	
	cmd = paste_parse(arg1);	
	IS_ARGUMENT(player, (cmd));

	notify(player, "|C+|[|Y+|PASTE|C+|]|W+|: |C|Ready to paste... |W+|(|C+|. |C|saves, |C+|.abort|C| aborts|W+|)");			
	d->paste_flag = 1;
	strcpy(d->paste_cmd = (char *)malloc(strlen(cmd)+1), cmd);
}