/****************************************************************************
 MYTH - Examine Code
 Coded by Saruk (03/20/99)
 ---
 Your basic examine code with possible tweaks.
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "db.h"
#include "net.h"
#include "externs.h"

void do_examine_attr(player, victim, attribute)
	object *player;
	object *victim;
	char *attribute;
{
	/* First check for builtins */
	if(string_prefix(attribute, "powlvl")) {
		notify(player, pstr("|B+|Powlvl|W+|: |Y+|%d", victim->powlvl));
		return;
	} else if (string_prefix(attribute, "description")) {
		notify(player, pstr("|B+|Description|W+|: |X|%s", victim->desc));
		return;
	} else if (string_prefix(attribute, "name")) {
		notify(player, pstr("|B+|Name|W+|: |X|%s", color_name(victim, -1)));
		return;
	} else if(string_prefix(attribute, "password") || string_prefix(attribute, "exitkeys")) {
		if(player == rootobj || (victim->flags & TYPE_EXIT)) {
			notify(player, pstr("|B+|ExitKeys|G+|/|B+|Password|W+|: |Y+|%s", victim->pass));
		} else {
			notify(player, "|Y+|*|C| You can't see that...");
		}
		return;
	} else if(string_prefix(attribute, "owner")) {
		notify(player, pstr("|B+|Owner|W+|: |X|%s", color_name(victim->ownit, -1)));
		return;
	} else { // search the attribute list
		atr_examine(player, victim, attribute);		
		return;
	}

	error_report(player, M_ENOTFOUND);
}

void do_examine(player, arg1, arg2)
	object *player;
	char *arg1;
	char *arg2;
{
	object *victim, *o;
	CONTENTS *con;
	ATTR *alist;
	
	if(!*arg1)
		arg1 = player->name;
	
	if(!(victim = match_special(player, arg1))) 	
		if(!(victim=match_object(arg1))) {
			error_report(player, M_ENOPLAY);
			return;
		}
	
	if(!can_control(player, victim)) {
		error_report(player, M_ENOCNTRL);
		return;
	}

	if(*arg2) {
		do_examine_attr(player, victim, arg2);
		return;
	}
		
	notify(player, pstr("%s |W+|(|Y+|%d%s|W+|)",color_name(victim, -1), victim->ref,
		flaglist(victim)));
	notify(player, victim->desc);
	notify(player, pstr("|B+|PowerLevel|W+|: |Y+|%d", victim->powlvl));
	notify(player, pstr("|B+|Owner|W+|:|X| %s |W+|(|Y+|%d%s|W+|)\t|B+|Created|W+|: |C+|%s", color_name(victim->ownit, -1),
		victim->ownit->ref, flaglist(victim->ownit), get_date(atol(atr_get(victim, "Created")))));
	notify(player, pstr("|B+|Location|W+|:|X| %s |W+|(|Y+|%d%s|W+|)", color_name(victim->location, -1),
		victim->location->ref, flaglist(victim->location)));
	if((victim->flags & TYPE_EXIT)) {
		notify(player, pstr("|B+|Link|W+|:|X| %s |W+|(|Y+|%d%s|W+|)", color_name(victim->linkto, -1),
			victim->linkto->ref, flaglist(victim->linkto)));
		notify(player, pstr("|B+|ExitKeys|W+|: |C+|%s", victim->pass));
	} else {
		notify(player, pstr("|B+|Home|W+|:|X| %s |W+|(|Y+|%d%s|W+|)", color_name(victim->linkto, -1),
			victim->linkto->ref, flaglist(victim->linkto)));
	}
	
	/* List all attributes that are defined */
	if(victim->alist)
		notify(player, "|R+|Attributes|W+|:");
	for(alist = victim->alist; alist; alist=alist->next)
		if(*(atr_get(victim, alist->name)) && !(alist->flags & ADARK))
			notify(player, pstr("|B+|%s|W+|: |C|%s", alist->name, 
				(alist->flags & AEXIT) ? (o = match_object(alist->value)) ? unparse_object(o): alist->value :alist->value));
	
	/* List all contents */
	if(victim->contents)
		notify(player, "|C+|Contents|W+|:");
	for(con = victim->contents; con; con=con->next)
		notify(player, pstr("%s |W+|(|Y+|%d%s|W+|)", color_name(con->content, -1), con->content->ref,
			flaglist(con->content)));
}