/****************************************************************************
 MYTH - Anything to do with looking at objects, database, etc.
 Coded by Saruk (01/25/99)
 ---
 Your basic 'eyes' part of MYTH.
 ****************************************************************************/
#include <stdlib.h> 
#include <stdio.h>
#include <string.h>

#include "db.h" 
#include "net.h"
#include "externs.h"

char *topic_str = "";

// display TYPE_PLAYER contents of victim to player.
void SHOW_PLAYERS(player, victim)
	object *player;
	object *victim;
{
	CONTENTS *c;
	int flagit = 0;	// flagit set to 1 if there are any TYPE_PLAYER contents;
	
	for(c=victim->contents;c;c=c->next)
		if((c->content->flags & TYPE_PLAYER) && (c->content->flags & CONNECT) && (can_control(player, c->content) || !(c->content->flags & INVISIBLE)))
			flagit = 1;
	
	if(!flagit)	
		return;
			
	notify(player, "|B+|Players|W+|:");
	for(c=victim->contents;c;c=c->next)
		if( (c->content->flags & CONNECT) && (c->content->flags & TYPE_PLAYER) 
			&& c->content != player && (can_control(player, c->content) || !(c->content->flags & INVISIBLE)))
			notify(player, pstr("%s |C+|(|Y+|%d%s|C+|) |C|is here.", color_name(c->content, -1), 
				c->content->ref, flaglist(c->content)));
		else if ( (c->content->flags & TYPE_PLAYER) && c->content == player )
			notify(player, "|Y+|You |C|are here.");
}

// display TYPE_THING contents of victim to player
void SHOW_CONTENTS(player, victim)
	object *player;
	object *victim;
{
	CONTENTS *c;
	int flagit = 0;	// flagit set to 1 if there are any TYPE_THING contents;
	
	for(c=victim->contents;c;c=c->next) 
		if( (c->content->flags & TYPE_THING) )
			flagit = 1;
	
	if(!flagit)
		return;
				
	notify(player, "|C+|Contents|W+|:");
	for(c=victim->contents; c; c=c->next)
		if( (c->content->flags & TYPE_THING)
			)
			notify(player, pstr("%s |C+|(|Y+|%d%s|C+|)", color_name(c->content, -1),
				c->content->ref, flaglist(c->content)));
}

// display TYPE_EXIT contents of victim to player
void SHOW_EXITS(player, victim)
	object *player;
	object *victim;
{
	CONTENTS *c;
	attr *a;
	int flagit = 0;	// flagit set to 1 if content->flag is TYPE_EXIT;
	
	for(a=victim->alist; a; a=a->next)
		if( (a->flags & AEXIT) && !(a->flags & ADARK) && *(atr_get(victim, a->name)) )
				flagit = 1;
				
	for(c=victim->contents;c;c=c->next)
		if((c->content->flags & TYPE_EXIT) && !(c->content->flags & HIDDEN))
			flagit = 1;
	
	if(!flagit)
		return;
		
	notify(player, "|M+|Exits|W+|:");
	for(a = victim->alist; a; a=a->next)
		if((a->flags & AEXIT) && *(atr_get(victim, a->name)) && !(a->flags & ADARK))
			__notify(player, pstr("|W+|[|X|%s|W+|]", show_pseudo_exit(a->name)), 0);
	
	for(c=victim->contents; c; c=c->next)
		if( (c->content->flags & TYPE_EXIT) && (!(c->content->flags & HIDDEN)) )
			__notify(player, pstr("|W+|[|X|%s |C+|(|Y+|%d%s|C+|)|W+|]",color_name(c->content, -1), 
				c->content->ref, flaglist(c->content)), 0);
	
	notify(player, "");
}

// look at matched arg1
void do_look_at(player, arg1)
	object *player;
	char *arg1;
{
	object *victim;
	
	if(!(victim = match_partial(player->location, arg1))) {
		if(!(victim=match_special(player, arg1))) {
			if(!(victim = match_object(arg1))) {
				error_report(player, M_EILLNAME);
				return;
			}
		}
	}
	
	if( victim->location != player->location && !can_control(player, victim) ) {
		error_report(player, M_ENOCNTRL);
		return;
	}
	
	notify(player, pstr("%s |C+|(|Y+|%d%s|C+|) %s%s%s", color_name(victim, -1), victim->ref, flaglist(victim),
		"", "", ""
		));
	notify(player, substitute(victim->desc));
	SHOW_PLAYERS(player, victim);
	SHOW_CONTENTS(player, victim);
	SHOW_EXITS(player, victim);
	if(player->flags & NOSPOOF)
		notify(player, pstr("|W+|(|C|Object Ref|W+|: |Y+|%d|W+|)", victim->ref));
}

// look at player's location or arg1.
void do_look(player, arg1)
	object *player;
	char *arg1;
{	
	
	if(*arg1) {
		do_look_at(player, arg1);
		return;
	}
		
	notify(player, pstr("%s |C+|(|Y+|%d%s|C+|) %s%s%s", color_name(player->location, -1), player->location->ref, flaglist(player->location),
		"", "", ""
		));
	notify(player, substitute(player->location->desc));
	
	SHOW_PLAYERS(player, player->location);	
	SHOW_CONTENTS(player, player->location);
	SHOW_EXITS(player, player->location);
	if(player->flags & NOSPOOF)
		notify(player, pstr("|W+|(|C|Object Ref|W+|: |Y+|%d|W+|)", player->location->ref));
}

char *who_flags(player)
	object *player;
{
	static char buf[MAX_BUFSIZE];

	strcpy(buf, "");	
	if(player->flags & WIZARD)
		strcat(buf, "W");
	if(player->flags & QUIET)
		strcat(buf, "q");
	if(player->flags & GUEST)
		strcat(buf, "G");
	if(player->flags & INVISIBLE)
		strcat(buf, "i");
	if(player->flags & NO_WALLS)
		strcat(buf, "n");
	
	if(buf[strlen(buf)-1] == '\n')
		buf[strlen(buf)-1] = '\0';
	
	return buf;	
}

// show who is online.
void do_who(player, arg1, arg2)
	object *player;
	char *arg1;
	char *arg2;
{
	DESCRIPTOR *d;
	int ctr = 0;
	
	// WHO Header.
	make_header(player, "|W+|--- |C|WHO LIST |W+|---");
	notify(player, pstr("|W+|%-12.12s %-5.5s %10.10s %5.5s %5.5s %-36.36s", 
		"NAME", "ALIAS", "ONFOR", "IDLE", "FLG", "DOING"));

	// Search the list for CONNECTED and NOT INVISIBLE players.
	for(d = descriptor_list; d; d=d->next) {
		if(d->state == CONNECTED) {
			if((!(d->player->flags & INVISIBLE)) || can_control(player, d->player)) {
				ctr++;
				notify(player, pstr("%s %s %10.10s %5.5s %5.5s %s|X|",
					color_name(d->player, 12), format_color(*(atr_get(d->player, "Alias")) ? atr_get(d->player, "Alias") : " ", 5),
					time_format(time(0) - d->connected_at), count_idle(time(0) - d->last_time),
					who_flags(d->player), format_color(atr_get(d->player, "DOING"),36)));
				
			}
		}
	}
	notify(player, pstr("|B|%s", make_ln("-", 78)));
	notify(player, pstr("|C|Comment|W+|:|X| %s", ((topic_str)) ? substitute(topic_str) : "Empty!"));
	notify(player, pstr("|B|%s", make_ln("-", 78)));
	notify(player, pstr("|B+|Current Time|W+|: |C+|%s\t|B+|Total Players|W+|: |Y+|%d",
			get_date(time(0)), ctr));
	notify(player, pstr("|B+|%s", make_ln("=", 78)));
}

void do_comment(player, arg1)
	object *player;
	char *arg1;
{
	char buf[MAX_BUFSIZE];
	
	if(*arg1 == '+') 
		sprintf(buf, "%s%s", topic_str, arg1 + 1);
	else 
		strcpy(buf, arg1);
		
	if(topic_str)
		free(topic_str);
	topic_str = NULL;
	
	if(!arg1 || !*arg1) {
		notify(player, "|Y+|* |C|Comment cleared!");
		return;
	}
	
	sprintf(buf, "%s |W+|--|X|%s", buf, color_name(player, -1));
	SET(&topic_str, buf);
	
	notify(player, pstr("|C|Topic changed to|W+|:|X| %s",topic_str));
	world_dwrite_q(pstr("%s |C|changed the comment!\n", color_name(player, -1)));
	log_channel("log_misc", pstr("|Y+|* |X|%s |C|changed the comment|W+|: |X|%s", 
		color_name(player, -1), topic_str));
}