/****************************************************************************
 MYTH - Timer/Time routines
 Coded by Saruk (01/27/99)
 ---
 Timer routines and some time stuff.
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "db.h"
#include "net.h"
#include "externs.h"

/* Timer declarations */
int myth_ticks = 0;
int database_saves = 0;
int dump_time = 1800;
int update_time = 0;
time_t last_dump_time = 0;
time_t last_update = 0;

// Return the date.
char *get_date(intm)
	time_t intm;
{
	static char buf[512];
	
	strcpy(buf, ctime(&intm));
	
	if(buf[strlen(buf)-1]=='\n')
		buf[strlen(buf)-1]='\0';
		
	return buf;
}

// A nice time format return.
char *time_format2(intm)
	time_t intm;
{
	static char buf[1024];
	char times[5][24];
	struct tm *delta;
	int weeks, days;

	for(weeks = 0; weeks < 5; weeks++)
		strcpy(times[weeks], "");
		
	if (intm < 0) intm = 0;	
	delta = gmtime(&intm);
	
	days = delta->tm_yday;
	
	if (days >= 7) {
		weeks = (days / 7);
		if ( (days = days - (weeks * 7)) < 0)
			days = 0;
	} else
		weeks = 0;

	delta->tm_year -= 70;		
	if(delta->tm_year > 0) {
		if (delta->tm_year > 1)
			sprintf(times[0], "%d years, ", delta->tm_year);
		else
			strcpy(times[0], "1 year, ");
	}
	
	if(weeks > 1)
		sprintf(times[0], "%s%d weeks, ", times[0], weeks);
	else if (weeks == 1)
		sprintf(times[0], "%s1 week, ", times[0]);
	
	if(days > 1)
		sprintf(times[1], "%d days, ", days);
	else if (days == 1)
		strcpy(times[1], "1 day, ");
		
	if(delta->tm_hour > 0) {
		if(delta->tm_hour > 1)
			sprintf(times[2], "%d hours, ", delta->tm_hour);
		else
			strcpy(times[2], "1 hour, ");
	}
	
	if (delta->tm_min > 0) {
		if(delta->tm_min > 1)
			sprintf(times[3], "%d minutes, and ", delta->tm_min);
		else
			strcpy(times[3], "1 minute, and ");
	}
	
	if (delta->tm_sec > 0) {
		if (delta->tm_sec > 1)
			sprintf(times[4], "%d seconds.", delta->tm_sec);
		else
			strcpy(times[4], "a second.");
	} else {
		strcpy(times[4], "0 seconds.");
	}	
	sprintf(buf, "%s%s%s%s%s", times[0], times[1], times[2], times[3], times[4]);
	
	return buf;
}

// Another style of returning time.
char *time_format(intm)
	time_t intm;
{
	static char buf[1024];
	struct tm *delta;
	int days;
	if (intm < 0) intm = 0;
	
	strcpy(buf, "");
	delta = gmtime(&intm);
	days = delta->tm_yday;
	
	if(days > 1)
		sprintf(buf, "%dd ",days);
	else if (days == 1)
		sprintf(buf, "1d ");

	sprintf(buf, "%s%02d:%02d",buf, delta->tm_hour, delta->tm_min);
	
	return buf;
}

// return length of idle by seconds, minutes, days, or weeks.
char *count_idle(intm)
	time_t intm;
{
	static char buf[1024];
	
	if(intm > 60) {
		if(intm > 3600) {
			if (intm > 86400) {
				if (intm > 604800) {
					strcpy(buf, pstr("%ldw", (intm / 604800)));
				} else {
					strcpy(buf, pstr("%ldd", (intm / 86400)));
				}
			} else {
				strcpy(buf, pstr("%ldh", (intm / 3600))); 
			}
		} else {
			strcpy(buf, pstr("%ldm", (intm / 60)));
		}
	} else {
		strcpy(buf, pstr("%lds", intm));
	}
	
	return buf;	
}

void do_timer()
{
	time_t now;
	
	time(&now);	
	myth_ticks++;
		
	if((now - last_dump_time) > dump_time) {
		database_saves++;
		if(database_saves > 15)
			database_saves = 0;
		fork_and_dump();
		sort_bboard();
		time(&last_dump_time);
	}

	if(resock) 
		do_resock();
}
